//###############################################################################
//#										#
//# universal microcontroller library						#
//#										#
//# copyright (c) 2010-2018 Joerg Wolfram (joerg@jcwolfram.de)			#
//#										#
//#										#
//# This program is free software; you can redistribute it and/or		#
//# modify it under the terms of the GNU General Public License			#
//# as published by the Free Software Foundation; either version 3		#
//# of the License, or (at your option) any later version.			#
//#										#
//# This program is distributed in the hope that it will be useful,		#
//# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
//# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
//# General Public License for more details.					#
//#										#
//# You should have received a copy of the GNU General Public			#
//# License along with this library// if not, write to the			#
//# Free Software Foundation, Inc., 59 Temple Place - Suite 330,		#
//# Boston, MA 02111-1307, USA.							#
//#										#
//###############################################################################
extern volatile PORT_TYPE CC2500_CSPORT;
extern volatile PORT_TYPE CC2500_CSPIN;
extern unsigned char aes_mode;
extern unsigned char aes_key_words;
extern unsigned char aes_rounds;
extern unsigned char aes_roundkey[240];
extern unsigned char* aes_key;
extern unsigned char hash_data[64];
extern unsigned long hash_state[8];
extern unsigned long hash_datalen;
extern unsigned long hash_bitlen;
extern volatile unsigned char unilib_debounce_num;
extern volatile unsigned char unilib_debounce_inc;
extern volatile unsigned char unilib_debounce_state;
extern volatile unsigned char unilib_debounce_values[8];
extern volatile PORT_TYPE unilib_debounce_ports[8];
extern volatile int unilib_debounce_pins[8];	
extern volatile PORT_TYPE enc_sel_port;
extern volatile int enc_sel_pin;
extern unsigned int enc_rxpos;
extern volatile PORT_TYPE unilib_glcd128ca_dataport;
extern volatile PORT_TYPE unilib_glcd128ca_ctrlport;
extern volatile unsigned char unilib_glcd128ca_wrpin;
extern volatile unsigned char unilib_glcd128ca_cdpin;
extern volatile unsigned int unilib_glcd128ca_bgcolor;
extern volatile unsigned int unilib_glcd128ca_fgcolor;
extern volatile unsigned char unilib_glcd128ca_cposx;
extern volatile unsigned char unilib_glcd128ca_cposy;
extern volatile unsigned int unilib_glcd128ca_dposx;
extern volatile unsigned int unilib_glcd128ca_dposy;
//#######################################################################
//#									#
//#	write cmd to display						#
//#									#
//#######################################################################
void _glcd128ca_cmd(unsigned char cmd);

//#######################################################################
//#									#
//#	write data to display						#
//#									#
//#######################################################################
void _glcd128ca_dbyte(unsigned char data);

//#######################################################################
//#									#
//#	write data to display						#
//#									#
//#######################################################################
void _glcd128ca_dword(unsigned int data);

extern volatile unsigned char unilib_gs4lcd_cposx;
extern volatile unsigned char unilib_gs4lcd_cposy;
extern volatile unsigned char unilib_gs4lcd_csizex;
extern volatile unsigned char unilib_gs4lcd_csizey;
extern volatile unsigned char unilib_gs4lcd_csizex0;
extern volatile unsigned char unilib_gs4lcd_csizey0;
extern volatile unsigned char unilib_gs4lcd_csizex1;
extern volatile unsigned char unilib_gs4lcd_csizey1;
extern volatile unsigned char unilib_gs4lcd_csizex2;
extern volatile unsigned char unilib_gs4lcd_csizey2;
extern volatile unsigned int unilib_gs4lcd_dposx;
extern volatile unsigned int unilib_gs4lcd_dposy;
extern volatile unsigned int unilib_gs4lcd_dsizex;
extern volatile unsigned int unilib_gs4lcd_dsizey;
extern volatile unsigned char unilib_gs4lcd_mode;
extern volatile unsigned char unilib_gs4lcd_fcolor;
extern volatile unsigned char unilib_gs4lcd_bcolor;
extern volatile unsigned char unilib_gs4lcd_font;
extern volatile unsigned char unilib_gs4lcd_fonth;
extern volatile unsigned char unilib_gs4lcd_sync;
extern volatile PORT_TYPE unilib_gs4lcd480a_ctrlport;
extern volatile unsigned char * unilib_gs4lcd480a_rptr;
extern volatile unsigned int unilib_gs4lcd480a_dpos;
extern volatile unsigned char unilib_gs4lcd480a_mpos;
extern volatile unsigned char unilib_gs4lcd480a_lp_pin;
extern volatile unsigned char unilib_gs4lcd480a_flm_pin;
extern volatile unsigned char unilib_gs4lcd480a_m_pin;
extern unsigned char unilib_gs4lcd480a_sdata[7680];
extern volatile unsigned char unilib_glcd_cposx;
extern volatile unsigned char unilib_glcd_cposy;
extern volatile unsigned char unilib_glcd_csizex;
extern volatile unsigned char unilib_glcd_csizey;
extern volatile unsigned char unilib_glcd_csizex0;
extern volatile unsigned char unilib_glcd_csizey0;
extern volatile unsigned char unilib_glcd_csizex1;
extern volatile unsigned char unilib_glcd_csizey1;
extern volatile unsigned char unilib_glcd_csizex2;
extern volatile unsigned char unilib_glcd_csizey2;
extern volatile unsigned int unilib_glcd_dposx;
extern volatile unsigned int unilib_glcd_dposy;
extern volatile unsigned int unilib_glcd_dsizex;
extern volatile unsigned int unilib_glcd_dsizey;
extern volatile unsigned char unilib_glcd_mode;
extern volatile unsigned char unilib_glcd_tcolor;
extern volatile unsigned char unilib_glcd_font;
extern volatile unsigned char unilib_glcd_fonth;
extern volatile unsigned char unilib_glcd_sync;
extern volatile PORT_TYPE unilib_glcd128a_dataport;
extern volatile PORT_TYPE unilib_glcd128a_ctrlport;
extern volatile unsigned char unilib_glcd128a_wbuffer[8];
extern volatile unsigned char unilib_glcd128a_dpos;
extern volatile unsigned char unilib_glcd128a_idle;
extern volatile unsigned char unilib_glcd128a_cmdsel;
extern volatile unsigned char unilib_glcd128a_cmdwrite;
extern volatile unsigned char unilib_glcd128a_data1sel;
extern volatile unsigned char unilib_glcd128a_data1write;
extern volatile unsigned char unilib_glcd128a_data2sel;
extern volatile unsigned char unilib_glcd128a_data2write;
extern volatile unsigned char unilib_glcd128a_sdata[1024];
//#######################################################################
//#									#
//#	write cmd to display						#
//#									#
//#######################################################################
void _glcd128a_cmd(unsigned char cmd);

//#######################################################################
//#									#
//#	write data byte to display					#
//#									#
//#######################################################################
void _glcd128a_wblock(void);

//#######################################################################
//#									#
//#	page select							#
//#									#
//#######################################################################
void _glcd128a_page(unsigned char pageno);

//#######################################################################
//#									#
//#	column select							#
//#									#
//#######################################################################
void _glcd128a_column(unsigned char column);

extern volatile PORT_TYPE unilib_glcd128b_dataport;
extern volatile PORT_TYPE unilib_glcd128b_ctrlport;
extern volatile unsigned char unilib_glcd128b_wbuffer[8];
extern volatile unsigned char unilib_glcd128b_dpos;
extern volatile unsigned char unilib_glcd128b_cmdsel;
extern volatile unsigned char unilib_glcd128b_datasel;
extern volatile unsigned char unilib_glcd128b_cmdwrite;
extern volatile unsigned char unilib_glcd128b_datawrite;
extern volatile unsigned char unilib_glcd128b_contrast;
extern volatile unsigned char unilib_glcd128b_sdata[1024];
//#######################################################################
//#									#
//#	write cmd to display						#
//#									#
//#######################################################################
void _glcd128b_cmd(unsigned char cmd);

//#######################################################################
//#									#
//#	write data byte to display					#
//#									#
//#######################################################################
void _glcd128b_wdata(unsigned char data);

//#######################################################################
//#									#
//#	write data byte to display					#
//#									#
//#######################################################################
void _glcd128b_wblock(void);

//#######################################################################
//#									#
//#	page select							#
//#									#
//#######################################################################
void _glcd128b_page(unsigned char pageno);

//#######################################################################
//#									#
//#	column select							#
//#									#
//#######################################################################
void _glcd128b_column(unsigned char column);

extern volatile PORT_TYPE unilib_glcd128c_dataport;
extern volatile PORT_TYPE unilib_glcd128c_ctrlport;
extern volatile unsigned char unilib_glcd128c_wbuffer[8];
extern volatile unsigned char unilib_glcd128c_dpos;
extern volatile unsigned char unilib_glcd128c_idle;
extern volatile unsigned char unilib_glcd128c_cmdsel;
extern volatile unsigned char unilib_glcd128c_cmdwrite;
extern volatile unsigned char unilib_glcd128c_data1sel;
extern volatile unsigned char unilib_glcd128c_data1write;
extern volatile unsigned char unilib_glcd128c_data2sel;
extern volatile unsigned char unilib_glcd128c_data2write;
extern volatile unsigned char unilib_glcd128c_sdata[1024];
//#######################################################################
//#									#
//#	write cmd to display						#
//#									#
//#######################################################################
void _glcd128c_cmd(unsigned char cmd);

//#######################################################################
//#									#
//#	write data byte to display					#
//#									#
//#######################################################################
void _glcd128c_wblock(void);

//#######################################################################
//#									#
//#	page select							#
//#									#
//#######################################################################
void _glcd128c_page(unsigned char pageno);

//#######################################################################
//#									#
//#	column select							#
//#									#
//#######################################################################
void _glcd128c_column(unsigned char column);

extern volatile PORT_TYPE unilib_glcd320a_ctrlport;
extern volatile PORT_TYPE unilib_glcd320a_dataport;
extern volatile unsigned char * unilib_glcd320a_rptr;
extern volatile unsigned char unilib_glcd320a_dpos;
extern volatile unsigned char unilib_glcd320a_mpos;
extern volatile unsigned char unilib_glcd320a_cp_pin;
extern volatile unsigned char unilib_glcd320a_lp_pin;
extern volatile unsigned char unilib_glcd320a_flm_pin;
extern volatile unsigned char unilib_glcd320a_doffset;
extern unsigned char unilib_glcd320a_sdata[9600];
extern volatile PORT_TYPE unilib_glcd320a_ctrlport;
extern volatile PORT_TYPE unilib_glcd320a_dataport;
extern volatile unsigned char * unilib_glcd320a_rptr;
extern volatile unsigned char unilib_glcd320a_dpos;
extern volatile unsigned char unilib_glcd320a_mpos;
extern volatile unsigned char unilib_glcd320a_cp_pin;
extern volatile unsigned char unilib_glcd320a_lp_pin;
extern volatile unsigned char unilib_glcd320a_flm_pin;
extern unsigned char unilib_glcd320a_sdata[9600];
extern volatile PORT_TYPE unilib_glcd320a_ctrlport;
extern volatile PORT_TYPE unilib_glcd320a_dataport;
extern volatile unsigned char * unilib_glcd320a_rptr;
extern volatile unsigned char unilib_glcd320a_dpos;
extern volatile unsigned char unilib_glcd320a_mpos;
extern volatile unsigned char unilib_glcd320a_cp_pin;
extern volatile unsigned char unilib_glcd320a_lp_pin;
extern volatile unsigned char unilib_glcd320a_flm_pin;
extern unsigned char unilib_glcd320a_sdata[9600];
extern volatile PORT_TYPE unilib_glcd320a_ctrlport;
extern volatile PORT_TYPE unilib_glcd320a_dataport;
extern volatile unsigned char * unilib_glcd320a_rptr;
extern volatile unsigned char unilib_glcd320a_dpos;
extern volatile unsigned char unilib_glcd320a_mpos;
extern volatile unsigned char unilib_glcd320a_cp_pin;
extern volatile unsigned char unilib_glcd320a_lp_pin;
extern volatile unsigned char unilib_glcd320a_flm_pin;
extern unsigned char unilib_glcd320a_sdata[9600];
extern volatile PORT_TYPE unilib_glcd320a_ctrlport;
extern volatile PORT_TYPE unilib_glcd320a_dataport;
extern volatile unsigned char * unilib_glcd320a_rptr;
extern volatile unsigned char unilib_glcd320a_dpos;
extern volatile unsigned char unilib_glcd320a_mpos;
extern volatile unsigned char unilib_glcd320a_cp_pin;
extern volatile unsigned char unilib_glcd320a_lp_pin;
extern volatile unsigned char unilib_glcd320a_flm_pin;
extern unsigned char unilib_glcd320a_sdata[9600];
extern volatile PORT_TYPE unilib_glcd480a_ctrlport;
extern volatile unsigned char * unilib_glcd480a_rptr;
extern volatile unsigned char unilib_glcd480a_dpos;
extern volatile unsigned char unilib_glcd480a_mpos;
extern volatile unsigned char unilib_glcd480a_lp_pin;
extern volatile unsigned char unilib_glcd480a_flm_pin;
extern volatile unsigned char unilib_glcd480a_m_pin;
extern unsigned char unilib_glcd480a_sdata[3840];
//#######################################################################
//# write value								#
//#######################################################################
unsigned char ov7431_write_byte(unsigned char addr, unsigned char byte);

extern unsigned long unilib_lfsr1_state;
extern unsigned long unilib_lfsr2_state;
extern volatile PORT_TYPE unilib_matrix_c57_row_port;
extern volatile PORT_TYPE unilib_matrix_c57_red_port;
extern volatile PORT_TYPE unilib_matrix_c57_green_port;
extern volatile unsigned char unilib_matrix_c57_state;
extern volatile unsigned char unilib_matrix_c57_cycles;
extern volatile PORT_TYPE unilib_matrix_c75_row_port;
extern volatile PORT_TYPE unilib_matrix_c75_red_port;
extern volatile PORT_TYPE unilib_matrix_c75_green_port;
extern volatile unsigned char unilib_matrix_c75_state;
extern volatile unsigned char unilib_matrix_c75_cycles;
extern volatile PORT_TYPE unilib_matrix_g16_row_port;
extern volatile PORT_TYPE unilib_matrix_g16_col1_port;
extern volatile PORT_TYPE unilib_matrix_g16_col2_port;
extern volatile unsigned char unilib_matrix_g16_state;
extern volatile unsigned char unilib_matrix_g16_cycle;
extern volatile unsigned char unilib_matrix_g16_max_row;
extern volatile PORT_TYPE unilib_matrix_g8_row_port;
extern volatile PORT_TYPE unilib_matrix_g8_col1_port;
extern volatile unsigned char unilib_matrix_g8_state;
extern volatile unsigned char unilib_matrix_g8_cycle;
extern volatile unsigned char unilib_matrix_g8_max_row;
extern volatile unsigned char unilib_matrix_g8_dir;
extern volatile PORT_TYPE unilib_matrix_m16_row_port;
extern volatile PORT_TYPE unilib_matrix_m16_col1_port;
extern volatile PORT_TYPE unilib_matrix_m16_col2_port;
extern volatile unsigned char unilib_matrix_m16_state;
extern volatile unsigned char unilib_matrix_m16_max_row;
extern volatile unsigned char unilib_matrix_m16_cycles;
extern volatile PORT_TYPE unilib_matrix_m8_row_port;
extern volatile PORT_TYPE unilib_matrix_m8_col1_port;
extern volatile unsigned char unilib_matrix_m8_state;
extern volatile unsigned char unilib_matrix_m8_max_row;
extern volatile unsigned char unilib_matrix_m8_cycles;
//#######################################################################
//# write data block							#
//#######################################################################
void mlx90363_comm(void);

//#######################################################################
//# NOP cmd								#
//#######################################################################
void mlx90363_nop(void);

//#######################################################################
//# get xyz								#
//#######################################################################
void mlx90363_get1xyz(void);

//#######################################################################
//# get alpha								#
//#######################################################################
void mlx90363_get1a(void);

//#######################################################################
//# get alpha								#
//#######################################################################
void mlx90363_get1ab(void);

extern volatile unsigned char RFM12_CSPORT;
extern volatile unsigned char RFM12_CSPIN;
extern volatile unsigned char unilib_rfm12_fmode;
extern volatile int unilib_stepper_steps[2];	
extern volatile unsigned char unilib_stepper_state[2];
extern volatile int unilib_stepper_scale[2];	
extern volatile int unilib_stepper_scale_stat[2];
extern volatile PORT_TYPE unilib_stepper_port[2];	
extern volatile int unilib_stepper_pin_mask[2];
extern volatile unsigned int unilib_stepper_pin_set[16];
extern volatile unsigned char unilib_tlcd_cposx;
extern volatile unsigned char unilib_tlcd_cposy;
extern volatile unsigned char unilib_tlcd_csizex;
extern volatile unsigned char unilib_tlcd_csizey;
extern volatile unsigned char unilib_tlcd_mode;
extern volatile unsigned char unilib_tlcd_color;
extern volatile unsigned char unilib_tlcd_sync;
extern volatile unsigned char *unilib_tlcd_sdata;
extern volatile unsigned char *unilib_tlcd_cgdata;
extern volatile PORT_TYPE unilib_tlcd161_n0_dataport;
extern volatile PORT_TYPE unilib_tlcd161_n0_ctrlport;
extern volatile unsigned char unilib_tlcd161_n0_rspin;
extern volatile unsigned char unilib_tlcd161_n0_epin;
extern volatile unsigned char unilib_tlcd161_n0_dpos;
extern volatile unsigned char unilib_tlcd161_n0_bcnt;
extern volatile unsigned char unilib_tlcd161_n0_cycle;
extern volatile unsigned char unilib_tlcd161_n0_wbyte;
extern volatile unsigned char unilib_tlcd161_n0_sdata[16];
extern volatile unsigned char unilib_tlcd161_n0_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n0_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n0_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161_n1_dataport;
extern volatile PORT_TYPE unilib_tlcd161_n1_ctrlport;
extern volatile unsigned char unilib_tlcd161_n1_rspin;
extern volatile unsigned char unilib_tlcd161_n1_epin;
extern volatile unsigned char unilib_tlcd161_n1_dpos;
extern volatile unsigned char unilib_tlcd161_n1_bcnt;
extern volatile unsigned char unilib_tlcd161_n1_cycle;
extern volatile unsigned char unilib_tlcd161_n1_wbyte;
extern volatile unsigned char unilib_tlcd161_n1_sdata[16];
extern volatile unsigned char unilib_tlcd161_n1_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n1_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n1_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161_n2_dataport;
extern volatile PORT_TYPE unilib_tlcd161_n2_ctrlport;
extern volatile unsigned char unilib_tlcd161_n2_rspin;
extern volatile unsigned char unilib_tlcd161_n2_epin;
extern volatile unsigned char unilib_tlcd161_n2_dpos;
extern volatile unsigned char unilib_tlcd161_n2_bcnt;
extern volatile unsigned char unilib_tlcd161_n2_cycle;
extern volatile unsigned char unilib_tlcd161_n2_wbyte;
extern volatile unsigned char unilib_tlcd161_n2_sdata[16];
extern volatile unsigned char unilib_tlcd161_n2_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n2_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n2_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161_n3_dataport;
extern volatile PORT_TYPE unilib_tlcd161_n3_ctrlport;
extern volatile unsigned char unilib_tlcd161_n3_rspin;
extern volatile unsigned char unilib_tlcd161_n3_epin;
extern volatile unsigned char unilib_tlcd161_n3_dpos;
extern volatile unsigned char unilib_tlcd161_n3_bcnt;
extern volatile unsigned char unilib_tlcd161_n3_cycle;
extern volatile unsigned char unilib_tlcd161_n3_wbyte;
extern volatile unsigned char unilib_tlcd161_n3_sdata[16];
extern volatile unsigned char unilib_tlcd161_n3_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n3_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161_n3_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161b_n0_dataport;
extern volatile PORT_TYPE unilib_tlcd161b_n0_ctrlport;
extern volatile unsigned char unilib_tlcd161b_n0_rspin;
extern volatile unsigned char unilib_tlcd161b_n0_epin;
extern volatile unsigned char unilib_tlcd161b_n0_dpos;
extern volatile unsigned char unilib_tlcd161b_n0_bcnt;
extern volatile unsigned char unilib_tlcd161b_n0_cycle;
extern volatile unsigned char unilib_tlcd161b_n0_wbyte;
extern volatile unsigned char unilib_tlcd161b_n0_sdata[16];
extern volatile unsigned char unilib_tlcd161b_n0_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n0_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n0_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161b_n1_dataport;
extern volatile PORT_TYPE unilib_tlcd161b_n1_ctrlport;
extern volatile unsigned char unilib_tlcd161b_n1_rspin;
extern volatile unsigned char unilib_tlcd161b_n1_epin;
extern volatile unsigned char unilib_tlcd161b_n1_dpos;
extern volatile unsigned char unilib_tlcd161b_n1_bcnt;
extern volatile unsigned char unilib_tlcd161b_n1_cycle;
extern volatile unsigned char unilib_tlcd161b_n1_wbyte;
extern volatile unsigned char unilib_tlcd161b_n1_sdata[16];
extern volatile unsigned char unilib_tlcd161b_n1_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n1_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n1_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161b_n2_dataport;
extern volatile PORT_TYPE unilib_tlcd161b_n2_ctrlport;
extern volatile unsigned char unilib_tlcd161b_n2_rspin;
extern volatile unsigned char unilib_tlcd161b_n2_epin;
extern volatile unsigned char unilib_tlcd161b_n2_dpos;
extern volatile unsigned char unilib_tlcd161b_n2_bcnt;
extern volatile unsigned char unilib_tlcd161b_n2_cycle;
extern volatile unsigned char unilib_tlcd161b_n2_wbyte;
extern volatile unsigned char unilib_tlcd161b_n2_sdata[16];
extern volatile unsigned char unilib_tlcd161b_n2_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n2_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n2_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd161b_n3_dataport;
extern volatile PORT_TYPE unilib_tlcd161b_n3_ctrlport;
extern volatile unsigned char unilib_tlcd161b_n3_rspin;
extern volatile unsigned char unilib_tlcd161b_n3_epin;
extern volatile unsigned char unilib_tlcd161b_n3_dpos;
extern volatile unsigned char unilib_tlcd161b_n3_bcnt;
extern volatile unsigned char unilib_tlcd161b_n3_cycle;
extern volatile unsigned char unilib_tlcd161b_n3_wbyte;
extern volatile unsigned char unilib_tlcd161b_n3_sdata[16];
extern volatile unsigned char unilib_tlcd161b_n3_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n3_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd161b_n3_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd162_n0_dataport;
extern volatile PORT_TYPE unilib_tlcd162_n0_ctrlport;
extern volatile unsigned char unilib_tlcd162_n0_rspin;
extern volatile unsigned char unilib_tlcd162_n0_epin;
extern volatile unsigned char unilib_tlcd162_n0_dpos;
extern volatile unsigned char unilib_tlcd162_n0_bcnt;
extern volatile unsigned char unilib_tlcd162_n0_cycle;
extern volatile unsigned char unilib_tlcd162_n0_wbyte;
extern volatile unsigned char unilib_tlcd162_n0_sdata[32];
extern volatile unsigned char unilib_tlcd162_n0_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n0_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n0_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd162_n1_dataport;
extern volatile PORT_TYPE unilib_tlcd162_n1_ctrlport;
extern volatile unsigned char unilib_tlcd162_n1_rspin;
extern volatile unsigned char unilib_tlcd162_n1_epin;
extern volatile unsigned char unilib_tlcd162_n1_dpos;
extern volatile unsigned char unilib_tlcd162_n1_bcnt;
extern volatile unsigned char unilib_tlcd162_n1_cycle;
extern volatile unsigned char unilib_tlcd162_n1_wbyte;
extern volatile unsigned char unilib_tlcd162_n1_sdata[32];
extern volatile unsigned char unilib_tlcd162_n1_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n1_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n1_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd162_n2_dataport;
extern volatile PORT_TYPE unilib_tlcd162_n2_ctrlport;
extern volatile unsigned char unilib_tlcd162_n2_rspin;
extern volatile unsigned char unilib_tlcd162_n2_epin;
extern volatile unsigned char unilib_tlcd162_n2_dpos;
extern volatile unsigned char unilib_tlcd162_n2_bcnt;
extern volatile unsigned char unilib_tlcd162_n2_cycle;
extern volatile unsigned char unilib_tlcd162_n2_wbyte;
extern volatile unsigned char unilib_tlcd162_n2_sdata[32];
extern volatile unsigned char unilib_tlcd162_n2_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n2_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n2_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd162_n3_dataport;
extern volatile PORT_TYPE unilib_tlcd162_n3_ctrlport;
extern volatile unsigned char unilib_tlcd162_n3_rspin;
extern volatile unsigned char unilib_tlcd162_n3_epin;
extern volatile unsigned char unilib_tlcd162_n3_dpos;
extern volatile unsigned char unilib_tlcd162_n3_bcnt;
extern volatile unsigned char unilib_tlcd162_n3_cycle;
extern volatile unsigned char unilib_tlcd162_n3_wbyte;
extern volatile unsigned char unilib_tlcd162_n3_sdata[32];
extern volatile unsigned char unilib_tlcd162_n3_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n3_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd162_n3_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd202_n0_dataport;
extern volatile PORT_TYPE unilib_tlcd202_n0_ctrlport;
extern volatile unsigned char unilib_tlcd202_n0_rspin;
extern volatile unsigned char unilib_tlcd202_n0_epin;
extern volatile unsigned char unilib_tlcd202_n0_dpos;
extern volatile unsigned char unilib_tlcd202_n0_bcnt;
extern volatile unsigned char unilib_tlcd202_n0_cycle;
extern volatile unsigned char unilib_tlcd202_n0_wbyte;
extern volatile unsigned char unilib_tlcd202_n0_sdata[40];
extern volatile unsigned char unilib_tlcd202_n0_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n0_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n0_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd202_n1_dataport;
extern volatile PORT_TYPE unilib_tlcd202_n1_ctrlport;
extern volatile unsigned char unilib_tlcd202_n1_rspin;
extern volatile unsigned char unilib_tlcd202_n1_epin;
extern volatile unsigned char unilib_tlcd202_n1_dpos;
extern volatile unsigned char unilib_tlcd202_n1_bcnt;
extern volatile unsigned char unilib_tlcd202_n1_cycle;
extern volatile unsigned char unilib_tlcd202_n1_wbyte;
extern volatile unsigned char unilib_tlcd202_n1_sdata[40];
extern volatile unsigned char unilib_tlcd202_n1_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n1_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n1_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd202_n2_dataport;
extern volatile PORT_TYPE unilib_tlcd202_n2_ctrlport;
extern volatile unsigned char unilib_tlcd202_n2_rspin;
extern volatile unsigned char unilib_tlcd202_n2_epin;
extern volatile unsigned char unilib_tlcd202_n2_dpos;
extern volatile unsigned char unilib_tlcd202_n2_bcnt;
extern volatile unsigned char unilib_tlcd202_n2_cycle;
extern volatile unsigned char unilib_tlcd202_n2_wbyte;
extern volatile unsigned char unilib_tlcd202_n2_sdata[40];
extern volatile unsigned char unilib_tlcd202_n2_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n2_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n2_byte(unsigned char data);

extern volatile PORT_TYPE unilib_tlcd202_n3_dataport;
extern volatile PORT_TYPE unilib_tlcd202_n3_ctrlport;
extern volatile unsigned char unilib_tlcd202_n3_rspin;
extern volatile unsigned char unilib_tlcd202_n3_epin;
extern volatile unsigned char unilib_tlcd202_n3_dpos;
extern volatile unsigned char unilib_tlcd202_n3_bcnt;
extern volatile unsigned char unilib_tlcd202_n3_cycle;
extern volatile unsigned char unilib_tlcd202_n3_wbyte;
extern volatile unsigned char unilib_tlcd202_n3_sdata[40];
extern volatile unsigned char unilib_tlcd202_n3_cgdata[64];
extern volatile unsigned char *dptr;		
//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n3_nibble(unsigned char data);

//#######################################################################
//#									#
//#	write nibble to display						#
//#									#
//#######################################################################
void _tlcd202_n3_byte(unsigned char data);

extern volatile unsigned char unilib_adc_mask;
extern volatile unsigned char unilib_adc_mode;
extern volatile unsigned char unilib_adc_chan;
extern unsigned long _dflash_xbuf[20];	
//#######################################################################
//#								 	#
//#	init tick/pwm timer				 		#
//#									#
//#######################################################################
void _init_timer2(unsigned long scale);

//#######################################################################
//#									#
//#	init tick/pwm timer						#
//#									#
//#######################################################################
void _init_timer3(unsigned long scale);

